//+==================================================================+
//|                                                  Lite_EXPERT.mqh |
//|                                  Version  November 1, 2008 Final |
//|                             Copyright  2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+==================================================================+
//----       
//        
int LastTime; 
//+------------------------------------------------------------------+
//| OpenBuyOrder()                                                   |
//+------------------------------------------------------------------+
int OpenBuyOrder(bool& BUY_Signal, double Money_Management, 
                                         int STOPLOSS, int TAKEPROFIT)
  {
//----+
   int ERROR = -1, TRADE = +1, NO_RESALT = 0; 
   //----
   if (!BUY_Signal)
            return(NO_RESALT);
   //----         
   if(TimeLocal() - LastTime < 11)
                         return(NO_RESALT);
   //---- 
   string Symb = Symbol();
   int pos, total = OrdersTotal();
   //----      
                         //     Buy 
   for(pos = total - 1; pos >= 0; pos--)     
     if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
          if (OrderSymbol() == Symb && OrderType() == OP_BUY)
                                                   return(NO_RESALT); 
   //---- 
   double MARGINREQUIRED, Lot, MINLOT, MAXLOT; 
   double LotVel, LOTSTEP, ask, Stoploss, TakeProfit; 
   //----
   if (Money_Management > 0)
     {        
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)
                            return(ERROR);
      //----              
      LotVel = AccountBalance()
                   * Money_Management / MARGINREQUIRED;         
     }
   else
      LotVel = MathAbs(Money_Management);
   //----  
   LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP);
   if (LOTSTEP <= 0)
              return(ERROR);  
              
   //----    
                          //    
   Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP); 
   
   //----      
   MINLOT = MarketInfo(Symb, MODE_MINLOT);
   if (MINLOT < 0)
         return(ERROR);
   //----      
   if (Lot < MINLOT)
         return(NO_RESALT);
          
   //----      
   MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
   if (MAXLOT < 0)
         return(ERROR);
   //----      
   if (Lot > MAXLOT)
          Lot = MAXLOT; 
   //----
   ask = NormalizeDouble(Ask, Digits); 
   if (ask == 0.0)
          return(ERROR);
   //----       
   Stoploss = NormalizeDouble(ask - STOPLOSS * Point, Digits);  
   TakeProfit = NormalizeDouble(ask + TAKEPROFIT * Point, Digits);
   
   //----+    
   int ticket = OrderSend(Symb, OP_BUY, Lot, ask, 3, 
                        Stoploss, TakeProfit, NULL, 0, 0, CLR_NONE); 
   //----
   LastTime = TimeLocal(); 
   //----
   if (ticket > 0)
     {
      BUY_Signal = false;
      return(TRADE);
     }
   else 
      return(ERROR);
//----+
  }
//+------------------------------------------------------------------+
//| OpenSellOrder()                                                  |
//+------------------------------------------------------------------+
int OpenSellOrder(bool& SELL_Signal, double Money_Management,
                                         int STOPLOSS, int TAKEPROFIT)
  {
//----+
   int ERROR = -1, TRADE = +1, NO_RESALT = 0; 
   //----
   if (!SELL_Signal)
            return(NO_RESALT);
   //----        
   if (TimeLocal() - LastTime < 11)
                         return(NO_RESALT);
   //---- 
   string Symb = Symbol(); 
   int pos, total = OrdersTotal();
   //----      
                          //     Sell 
   for(pos = total - 1; pos >= 0; pos--)     
     if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
           if (OrderSymbol() == Symb && OrderType() == OP_SELL)
                                                    return(NO_RESALT); 
   //---- 
   int SPREAD; 
   double MARGINREQUIRED, TICKVALUE, MINLOT, MAXLOT; 
   double LotVel, Lot, LOTSTEP, bid, Stoploss, TakeProfit; 
   //----
   if (Money_Management > 0)
     {        
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)
                            return(ERROR);            
      //----
      SPREAD = MarketInfo(Symb, MODE_SPREAD);
      //----
      TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
      //----
      LotVel = AccountBalance() * Money_Management / 
                    (MARGINREQUIRED - (SPREAD * TICKVALUE));           
     }
   else
      LotVel = MathAbs(Money_Management);
   //----  
   LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP);
   if (LOTSTEP <= 0)
              return(ERROR);  
              
   //----    
                          //    
   Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);  
  
   //----      
   MINLOT = MarketInfo(Symb, MODE_MINLOT);
   if (MINLOT < 0)
         return(ERROR);
   //----      
   if (Lot < MINLOT)
             return(NO_RESALT);
          
   //----      
   MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
   if (MAXLOT < 0)
         return(ERROR);
   //----      
   if (Lot > MAXLOT)
          Lot = MAXLOT; 
   //----
   bid = NormalizeDouble(Bid, Digits); 
   //----
   if (bid == 0.0)
          return(ERROR);
   //----       
   Stoploss = NormalizeDouble(bid + STOPLOSS * Point, Digits);         
   TakeProfit = NormalizeDouble(bid - TAKEPROFIT * Point, Digits);
   
   //----+    
   int ticket = OrderSend(Symb, OP_SELL, Lot, bid, 3, 
                         Stoploss, TakeProfit, NULL, 0, 0, CLR_NONE); 
   //----
   LastTime = TimeLocal(); 
   //----
   if (ticket > 0)
     {
      SELL_Signal = false;
      return(TRADE);
     }
   else 
      return(ERROR);
//----+
  }    
//+------------------------------------------------------------------+


